<?php

/*
This file sets up all the MySQL database and tables, as well as the functions needed in other scripts.
You should only edit the next few lines.
*/

//Change these two variables to your own MySQL username and password.
$mysqluser = "root";
$mysqlpass = "";

//Change this variable to your MySQL host's name.
$mysqlhost = "localhost";

//Change this variable to the file path of the form.
$form = "form.php";

//This variable defines the database name.
$dbname = "contact_me";

//Captcha toggle
$captchatoggle = TRUE;

//--------------------------------------------------
//----------Do not alter beyond this point----------
//--------------------------------------------------

//Starts session
session_start();

require_once('captcha/Captcha.php');
$captchaobject = new Captcha();

//Establish MySQL connection
$dbp = mysql_connect($mysqlhost, $mysqluser, $mysqlpass);
if(!$dbp) die('There was an error while connecting to the database'.mysql_error());
//This part sets up the database if not set up already
$result = mysql_query("CREATE DATABASE IF NOT EXISTS `$dbname`;", $dbp);mysql_select_db($dbname, $dbp);
//Creates table named "records"
$result = mysql_query("CREATE TABLE IF NOT EXISTS records (id INT NOT NULL PRIMARY KEY AUTO_INCREMENT,firstname VARCHAR (15) NOT NULL,surname VARCHAR (20) NOT NULL,email VARCHAR (40) NOT NULL,phoneno VARCHAR (15) NOT NULL, message TEXT NOT NULL, date VARCHAR (20) NOT NULL, replied TEXT NOT NULL, reply TEXT NOT NULL);", $dbp);
//Creates table named "administrators"
$result = mysql_query("CREATE TABLE IF NOT EXISTS administrators (id INT NOT NULL PRIMARY KEY AUTO_INCREMENT,username VARCHAR (12) NOT NULL,password VARCHAR (137) NOT NULL,adminemailaddress VARCHAR (60) NOT NULL,notificationoption TEXT NOT NULL);", $dbp);
//Creates an administrative account with username 'admin' and password 'admin'
$result = mysql_query("INSERT INTO administrators VALUES(1, 'admin', '21232f297a57a5a743894a0e4a801fc3', 'example@example.com', 'no');", $dbp);
//Stop error from being output to the page
error_reporting(0);
//Declare functions needed for the rest of script
function gotoPage($location) {
	print <<<HERE
	<script>location.href="$location"</script>
HERE;
}
function showErr($err_num,$fname, $sname, $email, $phoneno, $mes) {
	global $form;
	$err_num = base64_encode($err_num);
        $fname = urlencode($fname);
        $sname = urlencode($sname);
        $email = urlencode($email);
        $phoneno = urlencode($phoneno);
        $mes = urlencode($mes);
	print <<<HERE
	<script>location.href="$form?no=$err_num&fname=$fname&sname=$sname&email=$email&phoneno=$phoneno&mes=$mes"</script>
HERE;
}
function admin_showErr($place, $err_num) {
	$err_num = base64_encode($err_num);
	print <<<HERE
	<script>location.href="contactFormAdmin/$place?no=$err_num"</script>
HERE;
}
function validate($fname, $sname, $email, $email_con, $phoneno, $mes, $captchaentered) {
	global $dbp;
        global $captchaobject;
        global $captchatoggle;
	if (strlen($fname)<1 || strlen($sname)<1 || strlen($email)<1 || strlen($email_con)<1 || strlen($mes)<1) {
		//Execute if one or more of the fields were less than 2 characters
		showErr(0,$fname, $sname, $email, $phoneno, $mes);
	} else if($email!==$email_con) {
		//Execute if confirm email did not match email
		showErr(1,$fname, $sname, $email, $phoneno, $mes);
	} else if(strstr($email, "@")==NULL||strstr($email, ".")==NULL) {
		//Execute if email does not have an @ or a period(.)
		showErr(2,$fname, $sname, $email, $phoneno, $mes);
        } else if($captchatoggle == TRUE && ($captchaentered !== $captchaobject->getCaptcha(session_id()) || $captchaentered == null || $captchaentered == "")) {
                //Execute on captcha error
                showErr(3,$fname, $sname, $email, $phoneno, $mes);
	} else {
		//Execute if all the fields validate
		$date = date("d/M/Y");
		$new = "new";
                $noreply = "";
		$result = mysql_query("INSERT INTO records VALUES (NULL, '$fname', '$sname', '$email', '$phoneno', '$mes', '$date', '$new', '$noreply')", $dbp);
   		$tmp = mysql_fetch_assoc(mysql_query("SELECT * FROM administrators WHERE id=1"));
		$adminemail = $tmp['adminemailaddress']; 
                $notificationoption = $tmp['notificationoption'];
                $esubject = "New message at Contact Me Admin!";
                $emessage = "You have received a new message in your Contact Me Admin!";
		if ($notificationoption == "yes") {mail("$adminemail","$esubject","$emessage");}
		gotoPage("success_pageForwarder.php");
	}
}
function checklogin($username, $password) {
	global $dbp;
	//Check if username and password are valid
	$num_rows = mysql_num_rows(mysql_query("SELECT password FROM administrators WHERE username='$username'", $dbp));
	$tmp = mysql_fetch_assoc(mysql_query("SELECT password FROM administrators WHERE username='$username'", $dbp));
	if($num_rows==0) return false;
	else if($password!==$tmp['password'])  return false;
	else if($num_rows==1&&$password==$tmp['password']) return true;
	else return false;
}
function login($username) {
	$_SESSION['loggedin'] = "$username";
	gotoPage("contactFormAdmin/panelHome.php");
}
function logout() {
	if(isset($_SESSION['loggedin'])) {
		session_destroy();
		unset($_SESSION['loggedin']);
		gotoPage("contactFormAdmin/index.php");
	} else {
		gotoPage("javascript: history.go(-1)");
	}
}
function auth() {
	if((!isset($_SESSION['loggedin']))||(!$_SESSION['loggedin'])) gotoPage("index.php");
}
function changepw($username, $password) {
	global $dbp;
	$password = md5($password);
	$result = mysql_query("UPDATE administrators SET password='$password' WHERE username='$username';", $dbp);
	gotoPage("contactFormAdmin/panelHome.php");
}
function checkchangepw($username, $oldpw, $newpw, $newpw_con) {
	global $dbp;
	$oldpw = md5($oldpw);
	$temp = mysql_fetch_assoc(mysql_query("SELECT password FROM administrators WHERE username='$username'", $dbp));
	$realoldpw = $temp['password'];
	if($newpw!==$newpw_con) {
		admin_showErr('changePw.php', 1);
	} else if($realoldpw!==$oldpw) {
		admin_showErr('changePw.php', 3);
	} else {
		changepw($username, $newpw);
	}
}
function lastid($table) {
	$tmp = mysql_fetch_assoc(mysql_query("SELECT MAX(id) FROM $table"));
	return $tmp['MAX(id)'];
}
function firstid($table) {
	$tmp = mysql_fetch_assoc(mysql_query("SELECT MIN(id) FROM $table"));
	if($tmp['MIN(id)']==NULL) return 0;
	else return $tmp['MIN(id)'];
}
function deleteRecord($id) {
	global $dbp;
	$result = mysql_query("DELETE FROM records WHERE id=$id", $dbp);
}
?>