<?php
/*
	This page gets and processes information sent from another page.
*/
include_once 'config.inc.php';
//Check what page it's meant to be
$c = base64_decode(htmlentities(strip_tags(filter_input(INPUT_GET, 'c'))));
switch ($c) {
	case "fnext":
	//Process the information sent from the form
	if($_SERVER['REQUEST_METHOD']=='POST') {
		$fname = trim(strip_tags(filter_input(INPUT_POST, 'firstName')));
		$sname = trim(strip_tags(filter_input(INPUT_POST, 'lastName')));
		$email = trim(strip_tags(filter_input(INPUT_POST, 'email1')));
		$email_con = trim(strip_tags(filter_input(INPUT_POST, 'email2')));
		$phoneno = trim(strip_tags(filter_input(INPUT_POST, 'phone')));
		$mes = trim(strip_tags(filter_input(INPUT_POST, 'message')));
                $captchaentered = trim(strip_tags(filter_input(INPUT_POST, 'captcha')));
		validate($fname, $sname, $email, $email_con, $phoneno, $mes, $captchaentered);
	} else {
		//If values were not sent by POST method, go back a page in history
		gotoPage("javascript: history.go(-1)");
	}
	break;
	
	case "login":
	//Checks if username and password are valid
	if($_SERVER['REQUEST_METHOD']=='POST') {
		$username = htmlentities(strip_tags(filter_input(INPUT_POST, 'username')));
		$password = md5(htmlentities(strip_tags(filter_input(INPUT_POST, 'password'))));
		if(checklogin($username, $password)) {
			login($username);
		} else {
			admin_showErr('index.php', 0);
		}
	} else {
			gotoPage("javascript: history.go(-1)");
	}
	break;
	
	case "logout":
	//Logs user out
	logout();
	break;
	
	case "changepw":
	auth();
	if($_SERVER['REQUEST_METHOD']=='POST') {
		$oldpw = htmlentities(strip_tags(filter_input(INPUT_POST, 'oldpw')));
		$newpw = htmlentities(strip_tags(filter_input(INPUT_POST, 'newpw')));
		$newpw_con = htmlentities(strip_tags(filter_input(INPUT_POST, 'newpw_con')));
		checkchangepw($_SESSION['loggedin'], $oldpw, $newpw, $newpw_con);
	} else {
		gotoPage("javascript: history.go(-1)");
	}
	break;
	
	case "notifications":
	auth();
	if($_SERVER['REQUEST_METHOD']=='POST') {
		global $dbp;
		$adminemailaddress = htmlentities(strip_tags(filter_input(INPUT_POST, 'emailaddress')));
		$notificationoption = htmlentities(strip_tags(filter_input(INPUT_POST, 'notificationoption')));
		if ($notificationoption == "on") {
			$notificationoption = "yes";
		} else {
			$notificationoption = "no";
		}
		$result = mysql_query("UPDATE administrators SET adminemailaddress='$adminemailaddress' WHERE username='admin';", $dbp);
		$result = mysql_query("UPDATE administrators SET notificationoption='$notificationoption' WHERE username='admin';", $dbp);
		gotoPage("contactFormAdmin/panelHome.php");
	} else {
		gotoPage("javascript: history.go(-1)");
	}
	break;
	
	case "email":
	auth();
	$id = htmlentities(strip_tags(filter_input(INPUT_GET, 'w')));
	$eid = htmlentities(trim(strip_tags(filter_input(INPUT_GET, 'id'))));$id2 = base64_decode($eid);
	if($_SERVER['REQUEST_METHOD']=='POST') {
		$subject = htmlentities(strip_tags(filter_input(INPUT_POST, 'subject')));
		$email= htmlentities(strip_tags(filter_input(INPUT_POST, 'email')));
		$message = nl2br(htmlentities(strip_tags(filter_input(INPUT_POST, 'messageReply'))));
		$messagestore = $message;
		$message .= "<br/><br/><strong>Original Message:</strong><br/>";
		$message .= nl2br(htmlentities(strip_tags(filter_input(INPUT_POST, 'origmess'))));
		$date = date("d/M/Y");
		$reply = mysql_fetch_assoc(mysql_query("SELECT * FROM records WHERE id=$id2", $dbp));
		$reply = $reply['reply'];
		$reply .= "<strong>Date Sent:</strong> ".$date."<br/>";
		$reply .= "<strong>Subject:</strong> ".$subject."<br/>";
		$reply .= "<strong>Message:</strong><br/>".$messagestore."<br/><br/>";
		$strHeaders = "MIME-Version: 1.0\r\n";
		$strHeaders .= "Content-type: text/html; charset=iso-8859-1\r\n";
		if(mail("$email", "$subject", "$message", "$strHeaders")) {
			$changereplied = mysql_query("UPDATE records SET replied='replied' WHERE id='$id2';", $dbp);
			$addreply = mysql_query("UPDATE records SET reply='$reply' WHERE id='$id2';",$dbp);
			gotoPage("contactFormAdmin/panelHome.php");
		} else {
			admin_showErr('panelHome.php', 4);
		}
	} else {
			gotoPage("javascript: history.go(-1)");
	}
	break;
	
	case "delete":
	auth();
	$id = base64_decode(htmlentities(strip_tags(filter_input(INPUT_GET, 'id'))));
	deleteRecord($id);
	gotoPage("contactFormAdmin/panelHome.php");
	break;
	
	case "admin_error":
	auth();
	$no = base64_decode(htmlentities(strip_tags(filter_input(INPUT_GET, 'no'))));
	admin_showErr('panelHome.php', $no);
	break;
	
	default:
	//If the user did not come from a form page, go back a page in history
	print '<script>location.href="javascript: history.go(-1)"</script>';
	break;
}
?>